diff -r 3da9153bcf2d -r 0324c269b390 javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java
--- a/javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java	Mon Apr 22 15:45:02 2013 -0700
@@ -627,155 +182,23 @@
      * when adjacent pair of faces shared a smoothing group. Otherwise the faces
      * are rendered with a hard edge between them.
      *
-     * A null faceSmoothingGroups implies all faces in this mesh have a
+     * An empty faceSmoothingGroups implies all faces in this mesh have a
      * smoothing group value of 1.
      *
-     * Note: If faceSmoothingGroups is not null, faceSmoothingGroups.length must
+     * Note: If faceSmoothingGroups is not empty, faceSmoothingGroups.length must
      * be equal to faces.length/NUM_COMPONENTS_PER_FACE.
-     */
-    public final void setFaceSmoothingGroups(int[] faceSmoothingGroups) {
-        if (faceSmoothingGroups == null) {
-            this.faceSmoothingGroups = null;
-            setFaceSmoothingGroupCount(0);
-        } else {
-            // Check that faceSmoothingGroups.length is 1/NUM_COMPONENTS_PER_FACE of faces.length
-            if (faceSmoothingGroups.length != (faces.length / NUM_COMPONENTS_PER_FACE)) {
-                throw new IllegalArgumentException("faceSmoothingGroups.length has to be equal to (faces.length / NUM_COMPONENTS_PER_FACE).");
-            }
-
-            if ((this.faceSmoothingGroups == null)
-                    || (this.faceSmoothingGroups.length < faceSmoothingGroups.length)) {
-                this.faceSmoothingGroups = new int[faceSmoothingGroups.length];
-            }
-            System.arraycopy(faceSmoothingGroups, 0, this.faceSmoothingGroups, 0, faceSmoothingGroups.length);
-            // Store the valid faceSmoothingGroup count.
-            // Note this.faceSmoothingGroups.length can be bigger than faceSmoothingGroups.length.
-            setFaceSmoothingGroupCount(faceSmoothingGroups.length);
-        }
-
-        fsgDirty = true;
-        setDirty(true);
+     */    
+    public ObservableIntegerArray getFaceSmoothingGroups() {
+        return faceSmoothingGroups.get();
     }
 
-    /**
-     * Sets the faceSmoothingGroups associated with this {@code TriangleMesh}
-     * starting at the specified {@code index} using data in {@code faceSmoothingGroups} 
-     * starting at index {@code start} for {@code length} number of faceSmoothingGroups.
-     * The face smoothing group value is used to control the smoothing
-     * between adjacent faces.
-     *
-     * The face smoothing group is represented by an array of bits and up to 32
-     * unique groups is possible. The face smoothing group value can range from
-     * zero to all 32 groups. A face is said to belong to a group is by having
-     * the associated bit set. A value of 0 implies no smoothing group or hard
-     * edges. A face can have no or more smoothing groups. Smoothing is applied
-     * when adjacent pair of faces shared a smoothing group. Otherwise the faces
-     * are rendered with a hard edge between them.
-     *
-     * @param index the starting destination index in this TriangleMesh's faceSmoothingGroups array
-     * @param points source array of floats containing the new faceSmoothingGroups
-     * @param start starting source index in the faceSmoothingGroups array.
-     * @param length number of faceSmoothingGroup elements to be copied.
-     */
-    public final void setFaceSmoothingGroups(int index, int[] faceSmoothingGroups,
-                      int start, int length) {
-
-        if (index < 0 || start < 0 || length < 0) {
-            throw new IllegalArgumentException("index, start and length have to be non-zero");
-        }
-        
-        if ((start >= faceSmoothingGroups.length) || ((start + length) > faceSmoothingGroups.length)) {
-            throw new IllegalArgumentException("start or (start + length) is out of range for input faceSmoothingGroups");
-        }
-        int fsgCount = getFaceSmoothingGroupCount();
-        if ((index >= fsgCount) || 
-                ((index + length) > fsgCount)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's faceSmoothingGroups");
-        }
-
-        System.arraycopy(faceSmoothingGroups, start, this.faceSmoothingGroups, index, length);
-              
-        if (fsgRangeInfos == null) {
-            fsgRangeInfos = new int[MAX_RANGE_SIZE];
-        }
-         if (!fsgUpdateRange) {
-            fsgDirty = fsgUpdateRange = true;
-            fsgRangeInfos[RANGE_INDEX] = index;
-            fsgRangeInfos[RANGE_LENGTH] = length;
-        } else {
-            fsgDirty = true;
-            int fromIndex = Math.min(fsgRangeInfos[RANGE_INDEX], index);
-            int toIndex = Math.max(fsgRangeInfos[RANGE_INDEX] + fsgRangeInfos[RANGE_LENGTH], index + length);
-            fsgRangeInfos[RANGE_INDEX] = fromIndex;
-            fsgRangeInfos[RANGE_LENGTH] = toIndex - fromIndex;
-        }
-        setDirty(true);
-    }
-
-    /**
-     * Gets the face smoothing group for each face in this {@code TriangleMesh}
-     * @return an int array to smoothing group bits for each face
-     */
-    public final int[] getFaceSmoothingGroups(int[] faceSmoothingGroups) {
-        if (this.faceSmoothingGroups == null) {
-            return null;
-        }
-
-        int fsgCount = getFaceSmoothingGroupCount();
-        if ((faceSmoothingGroups == null) || 
-                (fsgCount > faceSmoothingGroups.length)) {
-            faceSmoothingGroups = new int[fsgCount];
-        }
-        System.arraycopy(this.faceSmoothingGroups, 0, faceSmoothingGroups, 0, fsgCount);
-        return faceSmoothingGroups;
-    }
-
-    /**
-     * Gets the face smoothing group for each face in this {@code TriangleMesh}
-     * starting at the specified {@code index} for {@code length} number of face
-     * smoothing groups.
-     * 
-     * @param index starting source face smoothing groups index in this {@code TriangleMesh}
-     * @param faceSmoothingGroups destination array that will receive this 
-     * {@code TriangleMesh}'s faceSmoothingGroups data
-     * @param length number of faceSmoothingGroup elements to be copied
-     * @return an int array of faceSmoothingGroups
-     */
-    public final int[] getFaceSmoothingGroups(int index, int[] faceSmoothingGroups, int length) {
-        if (index < 0 || length < 0) {
-            throw new IllegalArgumentException("index and length have to be non-zero");
-        }
-
-        if (length > faceSmoothingGroups.length) {
-            throw new IllegalArgumentException("length is out of range for input faceSmoothingGroups");
-        }
-        
-        int fsgCount = getFaceSmoothingGroupCount();
-        if ((index >= fsgCount) || ((index + length) > fsgCount)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's faceSmoothingGroups");
-        }
-
-        if (this.faceSmoothingGroups == null) {
-            return null;
-        }
-        System.arraycopy(this.faceSmoothingGroups, index, faceSmoothingGroups, 0, length);
-        return faceSmoothingGroups;
-    }
-
-    @Override
-    void setDirty(boolean value) {
+    @Override void setDirty(boolean value) {
         super.setDirty(value);
         if (!value) { // false
-            pointsDirty = false;
-            texCoordsDirty = false;
-            facesDirty = false;
-            fsgDirty = false;
-            pointUpdateRange = false;
-            texCoordUpdateRange = false;
-            faceUpdateRange = false;
-            fsgUpdateRange = false;
-            // We don't clear up XXXPartialUpdateInfos array since we will
-            // overwrite every element when we update the array.   
+            points.setDirty(false);
+            texCoords.setDirty(false);
+            faces.setDirty(false);
+            faceSmoothingGroups.setDirty(false);
         }
     }
 
@@ -831,42 +254,18 @@
 
         PGTriangleMesh pgTriMesh = impl_getPGTriangleMesh();
         // sync points 
-        if (pointsDirty) {
-            if (pointUpdateRange) {
-                pgTriMesh.setPoints(points, pointRangeInfos[RANGE_INDEX],
-                        pointRangeInfos[RANGE_LENGTH]);
-            } else {
-                pgTriMesh.setPoints(points);
-            }
+        if (points.isDirty()) {
+            pgTriMesh.syncPoints(points);
         }
-        // sync texCoords
-        if (texCoordsDirty) {
-            if (texCoordUpdateRange) {
-                pgTriMesh.setTexCoords(texCoords, texCoordRangeInfos[RANGE_INDEX],
-                                       texCoordRangeInfos[RANGE_LENGTH]);
-            } else {
-                pgTriMesh.setTexCoords(texCoords);
-            }
+        if (texCoords.isDirty()) {
+            pgTriMesh.syncTexCoords(texCoords);
         }
-        // sync faces
-        if (facesDirty) {
-            if (faceUpdateRange) {
-                pgTriMesh.setFaces(faces, faceRangeInfos[RANGE_INDEX],
-                                   faceRangeInfos[RANGE_LENGTH]);
-            } else {
-                pgTriMesh.setFaces(faces);
-            }
+        if (faces.isDirty()) {
+            pgTriMesh.syncFaces(faces);
         }
-        // sync faceSmoothingGroups
-        if (fsgDirty) {
-            if (fsgUpdateRange) {
-                pgTriMesh.setFaceSmoothingGroups(faceSmoothingGroups, fsgRangeInfos[RANGE_INDEX],
-                                                 fsgRangeInfos[RANGE_LENGTH]);
-            } else {
-                pgTriMesh.setFaceSmoothingGroups(faceSmoothingGroups);
-            }
+        if (faceSmoothingGroups.isDirty()) {
+            pgTriMesh.syncFaceSmoothingGroups(faceSmoothingGroups);
         }
-
         setDirty(false);
     }
 
@@ -875,9 +274,9 @@
         if (isDirty() || cachedBounds == null) {
             cachedBounds = new BoxBounds();
 
-            final double len = points.length;
-            for (int i = 0; i < len; i += 3) {
-                cachedBounds.add(points[i], points[i + 1], points[i + 2]);
+            final double len = points.get().size();
+            for (int i = 0; i < len; i += NUM_COMPONENTS_PER_POINT) {
+                cachedBounds.add(points.get().getValue(i), points.get().getValue(i + 1), points.get().getValue(i + 2));
             }
         }
         return bounds.deriveWithNewBounds(cachedBounds);
@@ -934,13 +333,13 @@
             PickRay pickRay, Point3D origin, Point3D dir, int faceIndex,
             CullFace cullFace, Node candidate, boolean reportFace, PickResultChooser result) {
 
-        final int v0Idx = faces[faceIndex] * 3;
-        final int v1Idx = faces[faceIndex + 2] * 3;
-        final int v2Idx = faces[faceIndex + 4] * 3;
+        final int v0Idx = faces.get().getValue(faceIndex) * NUM_COMPONENTS_PER_POINT;
+        final int v1Idx = faces.get().getValue(faceIndex + 2) * NUM_COMPONENTS_PER_POINT;
+        final int v2Idx = faces.get().getValue(faceIndex + 4) * NUM_COMPONENTS_PER_POINT;
 
-        final Point3D v0 = new Point3D(points[v0Idx], points[v0Idx + 1], points[v0Idx + 2]);
-        final Point3D v1 = new Point3D(points[v1Idx], points[v1Idx + 1], points[v1Idx + 2]);
-        final Point3D v2 = new Point3D(points[v2Idx], points[v2Idx + 1], points[v2Idx + 2]);
+        final Point3D v0 = new Point3D(points.get().getValue(v0Idx), points.get().getValue(v0Idx + 1), points.get().getValue(v0Idx + 2));
+        final Point3D v1 = new Point3D(points.get().getValue(v1Idx), points.get().getValue(v1Idx + 1), points.get().getValue(v1Idx + 2));
+        final Point3D v2 = new Point3D(points.get().getValue(v2Idx), points.get().getValue(v2Idx + 1), points.get().getValue(v2Idx + 2));
 
         final Point3D e1 = v1.subtract(v0);
         final Point3D e2 = v2.subtract(v0);
@@ -1028,13 +427,13 @@
 
             // Obtain the texture triangle
 
-            final int t0Idx = faces[faceIndex + 1] * 2;
-            final int t1Idx = faces[faceIndex + 3] * 2;
-            final int t2Idx = faces[faceIndex + 5] * 2;
+            final int t0Idx = faces.get().getValue(faceIndex + 1) * NUM_COMPONENTS_PER_TEXCOORD;
+            final int t1Idx = faces.get().getValue(faceIndex + 3) * NUM_COMPONENTS_PER_TEXCOORD;
+            final int t2Idx = faces.get().getValue(faceIndex + 5) * NUM_COMPONENTS_PER_TEXCOORD;
 
-            final Point2D u0 = new Point2D(texCoords[t0Idx], texCoords[t0Idx + 1]);
-            final Point2D u1 = new Point2D(texCoords[t1Idx], texCoords[t1Idx + 1]);
-            final Point2D u2 = new Point2D(texCoords[t2Idx], texCoords[t2Idx + 1]);
+            final Point2D u0 = new Point2D(texCoords.get().getValue(t0Idx), texCoords.get().getValue(t0Idx + 1));
+            final Point2D u1 = new Point2D(texCoords.get().getValue(t1Idx), texCoords.get().getValue(t1Idx + 1));
+            final Point2D u2 = new Point2D(texCoords.get().getValue(t2Idx), texCoords.get().getValue(t2Idx + 1));
 
             final Point2D txCentroid = computeCentroid(u0, u1, u2);
 
@@ -1082,7 +481,7 @@
             Node candidate, CullFace cullFace, boolean reportFace) {
 
         boolean found = false;
-        final int size = faces.length;
+        final int size = faces.get().size();
 
         final Vec3d o = pickRay.getOriginNoClone();
         final Point3D origin = new Point3D(o.x, o.y, o.z);
diff -r 3da9153bcf2d -r 0324c269b390 test-stub-toolkit/src/com/sun/javafx/pgstub/StubTriangleMesh.java
--- a/test-stub-toolkit/src/com/sun/javafx/pgstub/StubTriangleMesh.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/test-stub-toolkit/src/com/sun/javafx/pgstub/StubTriangleMesh.java	Mon Apr 22 15:45:02 2013 -0700
@@ -25,99 +25,32 @@
 
 package com.sun.javafx.pgstub;
 
+
+import com.sun.javafx.collections.FloatArraySyncer;
+import com.sun.javafx.collections.IntegerArraySyncer;
 import com.sun.javafx.sg.PGTriangleMesh;
-import javafx.scene.shape.TriangleMesh;
+
 
 public class StubTriangleMesh implements PGTriangleMesh {
 
     private float[] points;
     private float[] texCoords;
     private int[] faces;
-    private int[] smoothingGroups;
+    private int[] faceSmoothingGroups;
 
-
-    @Override
-    public void setPoints(float[] points) {
-        if (points == null) {
-            this.points = null;
-            return;
-        }
-        this.points = new float[points.length];
-        System.arraycopy(points, 0, this.points, 0, points.length);
+    @Override public void syncPoints(FloatArraySyncer array) {
+        points = array.syncTo(points);
+    }
+    
+    @Override public void syncTexCoords(FloatArraySyncer array) {
+        texCoords = array.syncTo(texCoords);
     }
 
-    @Override
-    public void setPoints(float[] points, int index, int length) {
-        if (points == null) {
-            this.points = null;
-            return;
-        }
-
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_POINT;
-        int lengthInFloatUnit = length * TriangleMesh.NUM_COMPONENTS_PER_POINT;
-        System.arraycopy(points, indexOffset, this.points, indexOffset, lengthInFloatUnit);
+    @Override public void syncFaces(IntegerArraySyncer array) {
+        faces = array.syncTo(faces);    
     }
 
-    @Override
-    public void setTexCoords(float[] texCoords) {
-        if (texCoords == null) {
-            this.texCoords = null;
-            return;
-        }
-        this.texCoords = new float[texCoords.length];
-        System.arraycopy(texCoords, 0, this.texCoords, 0, texCoords.length);
-    }
-
-    @Override
-    public void setTexCoords(float[] texCoords, int index, int length) {
-        if (texCoords == null) {
-            this.texCoords = null;
-            return;
-        }
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_TEXCOORD;
-        int lengthInFloatUnit = length * TriangleMesh.NUM_COMPONENTS_PER_TEXCOORD;
-        System.arraycopy(texCoords, indexOffset, this.texCoords, indexOffset, lengthInFloatUnit);
-    }
-
-    @Override
-    public void setFaces(int[] faces) {
-        if (faces == null) {
-            this.faces = null;
-            return;
-        }
-        this.faces = new int[faces.length];
-        System.arraycopy(faces, 0, this.faces, 0, faces.length);
-    }
-
-    @Override
-    public void setFaces(int[] faces, int index, int length) {
-        if (faces == null) {
-            this.faces = null;
-            return;
-        }
-        int indexOffset = index * TriangleMesh.NUM_COMPONENTS_PER_FACE;
-        int lengthInIntUnit = length * TriangleMesh.NUM_COMPONENTS_PER_FACE;
-        System.arraycopy(faces, indexOffset, this.faces, indexOffset, lengthInIntUnit);
-    }
-
-    @Override
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups) {
-        if (faceSmoothingGroups == null) {
-            this.smoothingGroups = null;
-            return;
-        }
-        this.smoothingGroups = new int[faceSmoothingGroups.length];
-        System.arraycopy(faceSmoothingGroups, 0, this.smoothingGroups, 0,
-                faceSmoothingGroups.length);
-    }
-
-    @Override
-    public void setFaceSmoothingGroups(int[] faceSmoothingGroups, int index, int length) {
-        if (faceSmoothingGroups == null) {
-            this.smoothingGroups = null;
-            return;
-        }
-
-        System.arraycopy(faceSmoothingGroups, index, this.smoothingGroups, index, length);
+    @Override public void syncFaceSmoothingGroups(IntegerArraySyncer array) {
+        faceSmoothingGroups = array.syncTo(faceSmoothingGroups);
     }
 }
